﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using VisualComponents.UX.Shared;
using VisualComponents.Create3D;
using System.ComponentModel.Composition;
using Caliburn.Micro;
using VC.WcfServiceDemo;
using System.Threading;

namespace VC.WcfHostDemo
{
    /// <summary>
    /// This opens or start the service
    /// </summary>
    [Export(typeof(IPlugin))]
    public class VCServiceHost : IPlugin
    {
        Thread callBackThread;
      
        public void Exit()
        {

        }

        public void Initialize()
        {
            StartWcf();
        }

        private void StartWcf()
        {
            Uri baseAddress = new Uri("http://localhost:8000/vcwcfdemo/service");
           
            string address = "net.pipe://localhost/vcwcfdemo/app";

            ServiceHost serviceHost = new ServiceHost(typeof(VCService), baseAddress);
            try
            {
                // define binding (NetNamedPipeBinding)
                NetNamedPipeBinding binding = new NetNamedPipeBinding(NetNamedPipeSecurityMode.None);
                serviceHost.AddServiceEndpoint(typeof(IVCService), binding, address);

                // Add a mex endpoint
                ServiceMetadataBehavior smb = new ServiceMetadataBehavior();
                smb.HttpGetEnabled = true;
                smb.HttpGetUrl = new Uri("http://localhost:8001/vcwcfdemo");
                serviceHost.Description.Behaviors.Add(smb);
                serviceHost.Open();

                // This is where I get instance of the VCServiceCallback. Note the use of new instance 
                // of Thread class.
                callBackThread = new Thread(VCServiceCallback.GetInstance().DoCallBacks);
                callBackThread.Start();

                IoC.Get<IMessageService>().AppendMessage("Service Ready.", MessageLevel.Warning);
            }
            catch (CommunicationException ce)
            {
                IoC.Get<IMessageService>().AppendMessage(ce.Message, MessageLevel.Warning);
                IoC.Get<IMessageService>().AppendMessage("Possible solution is to start VC 4.0 as administrator", MessageLevel.Warning);
                serviceHost.Abort();
            }
        }
    }
}
