﻿using System.Collections.Generic;
using System.ServiceModel;

namespace VC.WcfServiceDemo
{
    /// <summary>
    /// IVCServiceCallback interface is the interface that defines 
    /// the operations that the service can call on the client endpoint. The client must provide a class that 
    /// implements IVCServiceCallback of the duplex contract for receiving messages from the service.
    /// </summary>
    public interface IVCServiceCallback
    {
        [OperationContract (IsOneWay = true)]
        void GenericCallback(List<string> info);

        [OperationContract(IsOneWay = true)]
        void GenericCallback2(string info);

        [OperationContract(IsOneWay = true)]
        void OnSignal(bool signalValue, string signalname, string component);
    }
}
