﻿using System;
using System.Collections.Generic;

namespace VC.WcfServiceDemo
{
    public delegate void CallBackEventHandler();

    /// <summary>
    /// This is used to get instance of VCServiceCallback.
    /// </summary>
    public class VCServiceCallback
    {
        public List<IVCServiceCallback> subscribedClients = new List<IVCServiceCallback>();
   
        public VCServiceCallback()
        {

        }

        private static VCServiceCallback serviceCallbackInstance = null;
        public static VCServiceCallback GetInstance()
        {
            lock (typeof(VCServiceCallback))
            {
                if (serviceCallbackInstance == null)
                {
                    serviceCallbackInstance = new VCServiceCallback();
                }
                return serviceCallbackInstance;
            }
        }
     
        public event CallBackEventHandler CallbackEvent;
        public void DoCallBacks()
        {
            if (subscribedClients.Count > 0)
            {
                CallBackEventHandler caller = CallbackEvent;
                Array.ForEach(caller.GetInvocationList(), callback => (callback as CallBackEventHandler).BeginInvoke(null, null));
            }
        }
    }
}
